unit html_report;

interface

uses
   classes, windows,
   activex_shell, html_template;

type
  THTML_Report = class(TComponent,Iactivex_shell_executable)
  private
  protected
    // Iactivex_shell_executable
    function activex_shell_methods : AnsiString;
    function activex_shell_exec(method_name : AnsiString; var param: Variant): Variant;

{$ifdef VER100}
      // IUnknown
    function QueryInterface(const IID: TGUID; out Obj): Integer; stdcall;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
{$endif}

  public
    // report output stream
    Stream : TStream;
  published
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Apelseen', [THTML_Report]);
end;


// Iactivex_shell_executable

// definition of "ActiveX shell" methods
function  THTML_Report.activex_shell_methods : AnsiString;
begin
  result := 'write_hex,write_str';
end;

// implementation of "ActiveX shell" methods
function  THTML_Report.activex_shell_exec(method_name : AnsiString;
                                      var param: Variant): Variant;
 var  temp_str : String;
begin
  result := Unassigned;

  if (method_name = 'write_hex') then begin
    if VarIsArray(param) then begin
      temp_str := hex_to_str(var_to_string(param[0]));
      if Stream <> nil then Stream.write(PChar(temp_str)^,length(temp_str));
    end;
  end
  else if (method_name = 'write_str') then begin
    if VarIsArray(param) then begin
      temp_str := var_to_string(param[0]);
      if Stream <> nil then Stream.write(PChar(temp_str)^,length(temp_str));
    end;
  end;

end;

{$ifdef VER100}

// IUnknown
function THTML_Report.QueryInterface(const IID: TGUID; out Obj): Integer; stdcall;
begin
  if GetInterface(IID, Obj) then result := 0 else result := E_NOINTERFACE;
end;
function THTML_Report._AddRef: Integer; stdcall;
begin
  result := 0;
end;
function THTML_Report._Release: Integer; stdcall;
begin
  result := 0;
end;

{$endif}

end.