unit _Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Db, DBTables, Grids, DBGrids, html_template;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Query1: TQuery;
    DataSource2: TDataSource;
    Query2: TQuery;
    DBGrid2: TDBGrid;
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    HTML_Template1: Thtml_template;
    SaveDialog1: TSaveDialog;
    procedure HTML_Template1ScriptRun(Sender: TObject; script: String);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure HTML_Template1OpenURLError(Sender: TObject; URL,
      ErrorMessage: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
   activex_shell, html_report, ComObj, shellapi;

{$R *.DFM}


function check_by_guid(component_guid: String): Boolean;
 var v : Variant;
begin

  try
    v := CreateCOMObject(StringToGUID(component_guid));
    result := True;
  except
    result := False;
  end;

end;


procedure TForm1.HTML_Template1ScriptRun(Sender: TObject; script: String);
  var scripting, module: Variant;
      report   : Thtml_report;
begin

// creating an object which will provide a output functionality to the script  
  report := Thtml_report.Create(Self);
  report.Name := 'Report';

  try


// assigning an output stream to that object
  if not SaveDialog1.Execute() then Exit;
  report.Stream := TFileStream.Create(SaveDialog1.FileName, fmCreate);

// creating an instance of MS Script Control


  if not check_by_guid('{EE09B103-97E0-11CF-978F-00A02463E06F}') then begin
    ShowMessage('First install MS ActiveX Scripting.' + #13#13 + 'See  index.html  -> [ MS ActiveX Scripting ]');
    Exit;
  end;

  if not check_by_guid('{0E59F1D5-1FBE-11D0-8FF2-00A0D10038BC}') then begin
    ShowMessage('First install MS Script Control.' + #13#13 + 'See  index.html  -> [ MS ActiveX Scripting ]');
    Exit;
  end;

  try
    scripting := CreateOLEObject('ScriptControl');
  except
    ShowMessage('MS ScriptControl is not installed.' + #13#13 + 'See index.html about downloading and installation.');
    Exit;
  end;

  scripting. AllowUI  := False;
  scripting. Language := 'VBScript';

// creating a script module by using the "ActiveX Shell" technology
  module := scripting.Modules.Add('report_module', obj_to_variant(Self) );

// executing the script and receiving report
  module.ExecuteStatement(script);

// opening report
  ShellExecute(Application.Handle,PChar('open'),PChar(SaveDialog1.FileName),
               nil,nil,SW_SHOWNORMAL);

// freeing of objects
  finally
    if report.Stream <> nil then report.Stream.Free;
    report.Free;
  end;


end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ChDir( ExtractFilePath(ParamStr(0)) );
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  html_template1.RunScript := False;
  Memo1.Lines.Text := html_template1.prepare;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  html_template1.RunScript := True;
  html_template1.prepare;
end;


procedure TForm1.HTML_Template1OpenURLError(Sender: TObject; URL,
  ErrorMessage: String);
begin
  ShowMessage('Can not load template. URL = ' + URL);
end;

end.
