                                                                   
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED  
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.                                              
                                                                  
// Copyright  1999 Alexander Turin (ANT Systems).


// ANTS TFloppyFormat Delphi/C++ Builder Component 
// Sample Program
 

unit FFD1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, 
  StdCtrls, Gauges, ComCtrls, ExtCtrls, FFormat;

type
  TFFForm1 = class(TForm)
    rgMediaType: TRadioGroup;
    rgVerify: TRadioGroup;
    Panel1: TPanel;
    cbSystemLocation: TComboBox;
    cMakeBoot: TCheckBox;
    rg1: TRadioGroup;
    cUseCustomSN: TCheckBox;
    eSerNum: TEdit;
    eVolumeLabel: TEdit;
    Label1: TLabel;
    StatusBar1: TStatusBar;
    lFormat: TLabel;
    Panel3: TPanel;
    Panel2: TPanel;
    Gauge1: TGauge;
    Label2: TLabel;
    Label3: TLabel;
    lTrack: TLabel;
    lHead: TLabel;
    bFormat: TButton;
    bAbort: TButton;
    bClose: TButton;
    rgFormatCondition: TRadioGroup;
    rgDrive: TRadioGroup;
    Label4: TLabel;
    FloppyFormat1: TFloppyFormat;
    procedure FormCreate(Sender: TObject);
    procedure bCloseClick(Sender: TObject);
    procedure bFormatClick(Sender: TObject);
    procedure FloppyFormat1TrackFormat(Sender: TObject);
    procedure FloppyFormat1Verify(Sender: TObject);
    procedure FloppyFormat1BootWrite(Sender: TObject);
    procedure FloppyFormat1FatWrite(Sender: TObject);
    procedure FloppyFormat1RootWrite(Sender: TObject);
    procedure FloppyFormat1SystemWrite(Sender: TObject);
    procedure bAbortClick(Sender: TObject);
    procedure rgVerifyClick(Sender: TObject);
    procedure cUseCustomSNClick(Sender: TObject);
    procedure cMakeBootClick(Sender: TObject);
  private
    { Private declarations }
    NeedAbort: Boolean;
    OkFormat: Boolean;
  public
    { Public declarations }
  end;

var
  FFForm1: TFFForm1;

implementation

{$R *.DFM}

procedure TFFForm1.FormCreate(Sender: TObject);
begin
  FFForm1.Icon := Application.Icon;
  cbSystemLocation.ItemIndex := Ord(FloppyFormat1.SystemLocation);
end;

procedure TFFForm1.bCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TFFForm1.bFormatClick(Sender: TObject);
begin
  StatusBar1.SimpleText := '';
  with FloppyFormat1 do begin
    MakeBootable := cMakeBoot.Checked;
    DiskDrive := TDiskDrive(rgDrive.ItemIndex);
    MediaType := TMediaType(rgMediaType.ItemIndex+1);
    Verify := TVerify(rgVerify.ItemIndex);
    if MakeBootable then
      SystemLocation := TSystemLocation(cbSystemLocation.ItemIndex);
    if eVolumeLabel.Text<>'' then
      VolumeLabel := eVolumeLabel.Text;
    if cUseCustomSN.Checked and (eSerNum.Text<>'') then begin
      UseCustomSerNum := True;
      CustomSerNum := eSerNum.Text; 
    end;
    FormatCondition := TFormatCondition(rgFormatCondition.ItemIndex);
    NeedAbort := False;
    lFormat.Visible := True;
    Application.ProcessMessages;

    OkFormat := FormatDisk =0;

    if OkFormat then begin
      StatusBar1.SimpleText := ' OK. Serial Number: '+SerialNumber;
      eSerNum.Text := SerialNumber;
      eVolumeLabel.Text := VolumeLabel;
    end else
      StatusBar1.SimpleText := ErrorMessage;
    lFormat.Visible := False;
    lTrack.Caption := '0';
    lHead.Caption := '0';
    Gauge1.Progress := 0;
    Beep;
  end;
end;

procedure TFFForm1.FloppyFormat1TrackFormat(Sender: TObject);
begin
  with FloppyFormat1 do begin
    Cancel := NeedAbort;
    Gauge1.Progress := Progress;
    if (Verify<>VerOnly) then begin
      StatusBar1.SimpleText := ' ' + 'Format';
      lFormat.Caption := 'F';
    end;
    lTrack.Caption := IntToStr(CurrentTrack);
    lHead.Caption := IntToStr(CurrentHead);
  end;
end;

procedure TFFForm1.bAbortClick(Sender: TObject);
begin
  NeedAbort := True;
end;

procedure TFFForm1.rgVerifyClick(Sender: TObject);
begin
  FloppyFormat1.Verify := TVerify(rgVerify.ItemIndex);
end;

procedure TFFForm1.FloppyFormat1Verify(Sender: TObject);
begin
  lFormat.Caption := 'V';
  StatusBar1.SimpleText := ' ' + 'Verify';
  with FloppyFormat1 do begin
    if (Verify=VerOnly) or (Verify=VerAlways) then begin
      Cancel := NeedAbort;
      Gauge1.Progress := Progress;
      lFormat.Caption := 'V';
      lTrack.Caption := IntToStr(CurrentTrack);
      lHead.Caption := IntToStr(CurrentHead);
    end;
  end;
end;

procedure TFFForm1.FloppyFormat1BootWrite(Sender: TObject);
begin
  StatusBar1.SimpleText := ' ' + 'Writting Boot';
end;

procedure TFFForm1.FloppyFormat1FatWrite(Sender: TObject);
begin
  StatusBar1.SimpleText := ' ' + 'Writting Fat';
end;

procedure TFFForm1.FloppyFormat1RootWrite(Sender: TObject);
begin
  StatusBar1.SimpleText := ' ' + 'Writting Root';
end;

procedure TFFForm1.FloppyFormat1SystemWrite(Sender: TObject);
begin
  StatusBar1.SimpleText := ' ' + 'Writting System';
end;

procedure TFFForm1.cUseCustomSNClick(Sender: TObject);
begin
  eSerNum.Enabled := cUseCustomSN.Checked;
end;

procedure TFFForm1.cMakeBootClick(Sender: TObject);
begin
  cbSystemLocation.Enabled := cMakeBoot.Checked;
end;

end.
