{*************
 *
 * Copyright (c) 1997 CEO Systems Inc.
 *
 * Project....:
 * File.......: TagLst.pas
 * Autor......:
 * Date.......: 09 June 1997
 * Description:
 *
 * $Archive: /ide expert/classes/taglst.pas $
 *
 * $History: taglst.pas $
 * 
 * *****************  Version 1  *****************
 * User: Anton        Date: 6/27/97    Time: 1:37p
 * Created in $/ide expert/classes
 *
 *************}

unit TagLst;

interface


uses
  Classes;
  
type
  TTagType = (usNone, usClass, usProcedure, usFunction,
    usEvents, usPrivate, usProtected, usProperty, usPublic,
    usPublished, usImplement, usDestructor, usConstructor);

  RTagItem = record
    tagName: String;
    tagType: TTagType;
    tagSubType: TTagType;
    GroupNum: Integer;
    LineNum: Integer;
  end;


  TTagList = class (TList)
  private
    function GetItem (Index: Integer): RTagItem;

  public
    destructor Destroy; override;

    procedure Clear;
    function  Add (Item: RTagItem): Integer;
    procedure Insert (Index: Integer; Item: RTagItem);
    procedure Delete (Index: Integer);

    property Items[Index: Integer]: RTagItem read GetItem; default;
  end;

implementation

{*******************************************************************}
{*                        CLASS TTagList                           *}
{*******************************************************************}

destructor TTagList.Destroy;
begin
  Clear;
  inherited Destroy;
end;


{*************
* Name.......: GetItem
*}
function TTagList.GetItem (Index: Integer): RTagItem;
begin
  Result := RTagItem((inherited Items[Index])^);
end;


{*************
* Name.......: Clear
*}
procedure TTagList.Clear;
var
  I: Integer;
begin
  // Free all items stored in the list
  if Count <= 0 then Exit;
  for I := 0 to Count - 1 do
    Dispose (inherited Items[I]);
  // perform inherited clearing
  inherited Clear;
end;


{*************
* Name.......: Add
*}
function TTagList.Add (Item: RTagItem): Integer;
var
  PTagItem: ^RTagItem;
begin
  // Allocate new memory
  New (PTagItem);

  // copy in memory
  PTagItem^ := Item;

  // and add it as maked in parent class
  Result := inherited Add (PTagItem);
end;


{*************
* Name.......: Insert
*}
procedure TTagList.Insert (Index: Integer; Item: RTagItem);
var
  PTagItem: ^RTagItem;
begin
  // Allocate new memory
  New (PTagItem);

  // copy in memory
  PTagItem^ := Item;

  // and add it as maked in parent class
  inherited Insert (Index, PTagItem);
end;


{*************
* Name.......: Delete
*}
procedure TTagList.Delete (Index: Integer);
begin
  Dispose (inherited Items[Index]);
  inherited Delete (Index);
end;

end.
 