{*************
 *
 * Copyright (c) 1997 CEO Systems Inc.
 *
 * Project....:
 * File.......: GetSSVer.pas
 * Author.....: Anton A. Mints
 * Date.......: 10 June 1997
 * Description: Read file and extract first Source Safe version
 *             number form the text
 *
 * $Archive: /ide expert/units/getssver.pas $
 *
 * $History: getssver.pas $
 * 
 * *****************  Version 1  *****************
 * User: Anton        Date: 6/27/97    Time: 1:37p
 * Created in $/ide expert/units
 *
 *************}
 
unit GetSSVer;

interface

function GetSSVersionNum (FileName: String): Integer;

implementation

uses
  SysUtils;

{*************
* Name.......: GetVersionNum
* Description: Extract Source Safe version number from the file's header
* Notes......: Read file from the disk, it's working much faster.
*}
function GetSSVersionNum (FileName: String): Integer;
var
  Line: String;
  F: Text;

  {*************
  * Name.......: AnalizeLine
  * Description: Try to extract version number
  *}
  function AnalizeLine (Line: String): Integer;
  var
    I: Integer;
  begin
    // Assume nothing by default.
    Result := 0;

    // Check if it's line with Version word
    if Pos ('Version', Line) > 0 then
    begin
      // Delete everything upto the Version word
      Delete (Line, 1, Pos ('Version', Line) + 7);

      // remove all '*' from the rest of the line
      for I := 1 to Length (Line) do
      begin
        if ( Char (Line[I]) = '*' ) then
          Char (Line[I]) := ' ';
      end;

      // Convert to Version Number
      try
        Result := StrToInt (Trim (Line)) + 1;
      except
      end;
    end;
  end;

begin
  // Assume error by default
  Result := 0;

  // Try to open file
  AssignFile (F, FileName);
  Reset (F);

  repeat
    try
      ReadLn (F, Line);
    except
      Break;
    end;

    // Try to get version number
    Result := AnalizeLine (Line);

    // If version number was found - exit cycle
    if Result > 0 then Break;

  until ( EOF(F) );

  CloseFile (F);

end;

end.
