unit Tokens;

interface

function Token (Value: String; Num: Integer): String;
function NumToken (Value: String): Integer;

implementation

uses
  SysUtils;

const
  TokenDelimits = ' .,-();:';

function GetTokenPos (Value: String): Integer;
var
  iToken: Integer;
  pToken: Integer;

begin
  Result := 0;
  for iToken := Length (TokenDelimits) downto 1 do
  begin
    pToken := Pos (TokenDelimits[iToken], Value);
    if ( pToken > 0 ) and
        ( ( Result = 0 ) or (pToken < Result) ) then
      Result := pToken;
  end;
end;


function Token (Value: String; Num: Integer): String;
var
  TokenPos: Integer;

begin
  TokenPos := GetTokenPos (Value);

  // Remove Double tokens
  if ( TokenPos = 1 ) then
    begin
      Delete (Value, 1, 1);
      Result := Token (Value, Num)
    end

  else if ( Num <= 0 ) then
    Result := ''

  else if ( Num = 1 ) then
    begin
      if ( TokenPos > 0 ) then
        Result := Copy (Value, 1, TokenPos-1)
      else
        Result := Value;
    end

  else
    begin
      if ( TokenPos > 0 ) then
        Delete (Value, 1, TokenPos)
      else
        Value := '';

      Result := Token (Value, Num-1);
    end;
end;


function NumToken (Value: String): Integer;
var
  TokenPos: Integer;

begin
  TokenPos := GetTokenPos (Value);

  if ( TokenPos > 0 ) then
    begin
      Delete (Value, 1, TokenPos);
      // Double tokens case
      if (TokenPos = 1) then
        Result := NumToken (Value)
      else
        Result := NumToken (Value) + 1;
    end
  else
    if Length (Value) > 0 then
      Result := 1
    else
      Result := 0;
end;

end.
