//  TRAVELING SALESMAN PROJECT
//  GrMikeD - GrMikeD@usa.net

// Unit of the MainForm
unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Spin, ExtCtrls, Grids, TeeProcs, TeEngine, Chart,
  Series,TimeCount, URLLabel, jpeg, ShellAPI;

Const C=200;   //C is the MAX number of cities (nodes of the graph)

type
  TMainForm = class(TForm)
    RadioGroup: TRadioGroup;
    SpinEdit: TSpinEdit;
    Label1: TLabel;
    StatusBar: TStatusBar;
    Button: TButton;
    GroupBox: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Bevel1: TBevel;
    Label12: TLabel;
    CheckBox1: TCheckBox;
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Edit1: TEdit;
    Edit: TEdit;
    StringGrid: TStringGrid;
    Label11: TLabel;
    Label6: TLabel;
    SaveDialog: TSaveDialog;
    Button1: TButton;
    CheckBox2: TCheckBox;
    Label7: TLabel;
    Label10: TLabel;
    Label5: TLabel;
    TabSheet4: TTabSheet;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    TabSheet5: TTabSheet;
    Chart3: TChart;
    Series5: TBarSeries;
    Series6: TBarSeries;
    CheckBox5: TCheckBox;
    Button9: TButton;
    Button10: TButton;
    Chart2: TChart;
    PointSeries3: TPointSeries;
    PointSeries4: TPointSeries;
    LineSeries3: TLineSeries;
    LineSeries4: TLineSeries;
    CheckBox4: TCheckBox;
    Button8: TButton;
    Button6: TButton;
    Chart1: TChart;
    Series1: TPointSeries;
    Series2: TPointSeries;
    Series3: TLineSeries;
    Series4: TLineSeries;
    CheckBox3: TCheckBox;
    Button4: TButton;
    Button7: TButton;
    Panel2: TPanel;
    Label4: TLabel;
    StringGrid1: TStringGrid;
    Label14: TLabel;
    StringGrid2: TStringGrid;
    Button2: TButton;
    Button3: TButton;
    Image1: TImage;
    Label3: TLabel;
    Label13: TLabel;
    Label2: TLabel;
    Label15: TLabel;
    procedure ButtonClick(Sender: TObject);
    procedure SpinEditChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox5Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure EditChange(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Label15Click(Sender: TObject);
  private
    procedure initial(Sender: TObject);
    { Private declarations }
  public
    { Public declarations }
    Counter: TCounter;
  end;

var
   MainForm: TMainForm;
   V:integer;                       //the selected number of noded
   E:array[1..C,1..C] of integer;  //array of disctances (E[i,j]=cij)
   T:array[1..C+1] of integer;     //array of the optimal path found each time
   Costing:integer;            //the cost of the minimum path
   flops:integer;             //the number of FLOP consumed
   count:real;              //the time consumed
   algo:integer; //flag that is 1 or 2 whether you choose exhaustive or heuristic algorithm
   Best:integer;      //it is 0 when there is no path found (connectivity problem error)
   Con,Same,CanSame,Stop:boolean;   //secondary variables for the flow control

implementation

{$R *.DFM}

uses exhaustive,Heuristic;

procedure TMainForm.initial(Sender: TObject); //initialization
label 100;

var i,j,k:integer;

begin
  Costing:=0;
  V:=spinedit.Value;
  stringgrid.ColCount:=V+1;
  stringgrid.rowcount:=V+1;
  for i:=1 to stringgrid.RowCount-1 do
  begin
    stringgrid.Rows[i].text:='a'+inttostr(i);
    stringgrid.Cols[i].text:='a'+inttostr(i);
  end;
  if not(same) then
  begin
    randomize;        //loop that creates the random distances for the V cities
    for i:=1 to V do
        for j:=1 to V do
            begin
              if j=i then
              begin
                 E[i,j]:=-1;
                 Stringgrid.Cells[j,i]:=inttostr(-1);
              end;
              if j>i then
              begin
                 repeat
                 k:=random(500);
               until k<>0;
               if k mod 19 = 0 then  //loop that creates possible non-connected cities
                  k:=-1
               else
               begin
                  repeat
                    k:=random(500);
                  until k<>0;
               end;
               E[i,j]:=k;
               E[j,i]:=k;
               Stringgrid.Cells[j,i]:=inttostr(k);
               Stringgrid.Cells[i,j]:=inttostr(k);
            end;
    end;
  end
  else
  for i:=1 to V do
      for j:=1 to V do
          stringgrid.Cells[j,i]:=inttostr(E[i,j]);
  case radiogroup.ItemIndex of
     0: label8.Caption:='Exhaustive Solution';
     1: label8.Caption:='Heuristic Solution';
  end;
  label9.Caption:='for '+spinedit.Text+' nodes';
end;


procedure TMainForm.ButtonClick(Sender: TObject);
var i,j,k:integer;

begin
  if button.Caption='Stop' then
  begin
    stop:=true;
    edit.Text:='';
    edit1.Text:='';
    edit2.text:='0';
    edit3.text:='0 sec';
    edit4.text:='0';
    exit;
  end;
  val(spinedit.text,j,k);
  if (k<>0) then
  begin
    beep;
    messagedlg('Invalid number of vertices',mterror,[mbok],0);
    spinedit.Value:=3;
    spinedit.SetFocus;
    spinedit.SelectAll;
    exit;
  end
  else
  begin
    if (spinedit.Value>C)or(spinedit.Value<3) then
    begin
      beep;
      messagedlg('Invalid number of vertices',mterror,[mbok],0);
      spinedit.Value:=3;
      spinedit.SetFocus;
      spinedit.SelectAll;
      exit;
    end
  end;
  algo:=radiogroup.ItemIndex+1;
  cansame:=true;
  button.Caption:='Stop';
  stop:=false;
  initial(sender);
  spinedit.Enabled:=false;
  checkbox2.Enabled:=false;
  checkbox1.Enabled:=false;
  button1.Enabled:=false;
  radiogroup.Enabled:=false;
  edit.Enabled:=false;
  edit1.Enabled:=false;
  edit2.Enabled:=false;
  edit3.Enabled:=false;
  edit4.Enabled:=false;
  statusbar.Panels[1].text:='Please Wait...';
  statusbar.Repaint;
  flops:=0;
  edit2.text:='0';
  edit3.text:='0 sec';
  edit4.text:='0';
  counter.StartTimeCount;
  case radiogroup.ItemIndex of      //selection of the to run algorithm
    0: exhaust;
    1: heurist;
  end;
  button.Caption:='Start';
  statusbar.Panels[1].text:='';
  spinedit.Enabled:=not(checkbox1.checked);
  checkbox1.Enabled:=true;
  checkbox2.Enabled:=true;
  button1.Enabled:=not(checkbox2.checked);
  radiogroup.Enabled:=true;
  edit.Enabled:=true;
  edit1.Enabled:=true;
  edit2.Enabled:=true;
  edit3.Enabled:=true;
  edit4.Enabled:=true;
  edit.Clear;
  if stop=true then
     exit;
  if costing=0 then     // loop when there is connectivity problem
  begin
    edit.Text:='Connectivity problem for all vertices';
    edit1.Text:='';
    button1.Enabled:=false;
    beep;
  end
  else        //extraction of the results on success
  begin
    edit.Text:='';
    for i:=1 to V+1 do
        edit.Text:=edit.Text+'a'+inttostr(T[i]);
    edit1.Text:=inttostr(Costing);
    edit2.text:=inttostr(flops);
    count:=strtofloat(counter.elapsedsecs);
    edit3.text:=floattostrf(count,fffixed,4,4)+' sec';
    edit4.text:=(floattostr(round(flops/count)));
    if checkbox2.Checked then
       button1.OnClick(sender);
  end;
end;


procedure TMainForm.SpinEditChange(Sender: TObject);
begin
  cansame:=false;
  checkbox1.enabled:=false;
  if spinedit.Text='' then
     button.Enabled:=false
  else
     button.Enabled:=true;
end;



procedure TMainForm.Button1Click(Sender: TObject); //design of the graphs
var i:integer;

procedure drawstringgrid1;
var i:integer;

begin
 stringgrid1.RowCount:=series1.Count+1;
 for i:=0 to series1.Count-1 do
 begin
   stringgrid1.Cells[0,i+1]:=floattostr(series1.XValues.Value[i]);
   stringgrid1.Cells[1,i+1]:=floattostr(series1.YValues.Value[i]);
   stringgrid1.Cells[2,i+1]:=floattostrf(pointseries3.YValues.Value[i],fffixed,4,4);
   stringgrid1.Cells[3,i+1]:=floattostr(series5.YValues.Value[i]);
 end;
end;

procedure drawstringgrid2;
var i:integer;

begin
 stringgrid2.RowCount:=series2.Count+1;
 for i:=0 to series2.Count-1 do
 begin
   stringgrid2.Cells[0,i+1]:=floattostr(series2.XValues.Value[i]);
   stringgrid2.Cells[1,i+1]:=floattostr(series2.YValues.Value[i]);
   stringgrid2.Cells[2,i+1]:=floattostrf(pointseries4.YValues.Value[i],fffixed,4,4);
   stringgrid2.Cells[3,i+1]:=floattostr(series6.YValues.Value[i]);
 end;
end;


begin
  if algo=1 then
  begin

    for i:=0 to series1.XValues.Count-1 do
    begin
        if series1.XValues[i]=V then
        begin
           series1.Delete(i);
           pointseries3.Delete(i);
           series5.Delete(i);
           break;
        end;
    end;
    Series1.AddXY(V,flops ,'',clRed);
    pointseries3.AddXY(V,count,'',clRed);
    series5.AddXY(V,costing,'',clRed);

    drawstringgrid1;

  end
  else
  begin

    for i:=0 to series2.XValues.Count-1 do
    begin
        if series2.XValues[i]=V then
        begin
           series2.Delete(i);
           series6.Delete(i);
           pointseries4.Delete(i);
           break;
        end;
    end;
    Series2.AddXY(V,flops,'',clBlue);
    Series6.AddXY(V,costing,'',clBlue);
    pointseries4.AddXY(V,count,'',clBlue);

    drawstringgrid2;

  end;
end;


procedure TMainForm.FormCreate(Sender: TObject);
begin
  stringgrid1.Cells[1,0]:='flops';
  stringgrid1.Cells[2,0]:='time(sec)';
  stringgrid1.Cells[3,0]:='cost';
  stringgrid2.Cells[1,0]:='flops';
  stringgrid2.Cells[2,0]:='time(sec)';
  stringgrid2.Cells[3,0]:='cost';
  algo:=2;
  counter:=Tcounter.Create(self);
  PageControl1.ActivePageIndex:= 0;
  same:=false;
end;

procedure TMainForm.CheckBox1Click(Sender: TObject);
begin
  same:=not(same);
  spinedit.Enabled:=not(spinedit.Enabled);
end;

procedure TMainForm.CheckBox2Click(Sender: TObject);
begin
 if E[1,1]=0 then
 begin
   if button1.Enabled=true then
      button1.Enabled:=false
 end
 else
   button1.Enabled:=not(checkbox2.checked);
end;

procedure TMainForm.CheckBox3Click(Sender: TObject);
begin
  chart1.View3D:=not(chart1.View3D);
end;

procedure TMainForm.CheckBox4Click(Sender: TObject);
begin
  chart2.View3D:=not(chart2.View3D);
end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
  chart1.CopyToClipboardBitmap;
end;

procedure TMainForm.Button8Click(Sender: TObject);
begin
  chart2.CopyToClipboardBitmap;
end;

procedure TMainForm.Button6Click(Sender: TObject);
begin
 if savedialog.Execute then
    chart2.SaveToBitmapFile(savedialog.filename);
end;

procedure TMainForm.Button7Click(Sender: TObject);
begin
 if savedialog.Execute then
    chart1.SaveToBitmapFile(savedialog.filename);
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  counter.Free;
end;

procedure TMainForm.CheckBox5Click(Sender: TObject);
begin
  chart3.View3D:=not(chart3.View3D);
end;

procedure TMainForm.Button9Click(Sender: TObject);
begin
 chart3.CopyToClipboardBitmap;
end;

procedure TMainForm.Button10Click(Sender: TObject);
begin
 if savedialog.Execute then
    chart3.SaveToBitmapFile(savedialog.filename);
end;

procedure TMainForm.EditChange(Sender: TObject);
begin
  if stop=true then
     edit.Text:='';
end;

procedure TMainForm.Edit1Change(Sender: TObject);
begin
  if stop=true then
     edit1.Text:='';
end;

procedure TMainForm.Edit2Change(Sender: TObject);
begin
  if stop=true then
     edit2.Text:='0';
end;

procedure TMainForm.Edit3Change(Sender: TObject);
begin
  if stop=true then
     edit3.Text:='0 sec';
end;

procedure TMainForm.Edit4Change(Sender: TObject);
begin
  if stop=true then
     edit4.Text:='0';
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  stop:=true;
end;

procedure TMainForm.Button2Click(Sender: TObject);
var i:integer;

begin
  for i:=1 to stringgrid1.RowCount-1 do
  begin
      stringgrid1.Cells[1,i]:='';
      stringgrid1.Cells[2,i]:='';
      stringgrid1.Cells[3,i]:='';
  end;
  stringgrid1.Cells[0,1]:='';
  stringgrid1.RowCount:=2;
  pointseries3.Clear;
  series1.Clear;
  series5.Clear;
end;

procedure TMainForm.Button3Click(Sender: TObject);
var i:integer;

begin
  for i:=1 to stringgrid2.RowCount-1 do
  begin
      stringgrid2.Cells[1,i]:='';
      stringgrid2.Cells[2,i]:='';
      stringgrid2.Cells[3,i]:='';
  end;
  stringgrid2.Cells[0,1]:='';
  stringgrid2.RowCount:=2;
  series2.Clear;
  series6.Clear;
  pointseries4.Clear;
end;

procedure TMainForm.Label2Click(Sender: TObject);
begin
  ShellExecute(ValidParentForm(Self).Handle,'open',PChar('mailto:GrMikeD@usa.net?subject=For the TspSolver'),nil,nil,SW_SHOW)
end;

procedure TMainForm.Label15Click(Sender: TObject);
begin
  ShellExecute(ValidParentForm(Self).Handle,'open',PChar(Label15.Caption),nil,nil,SW_SHOW)
end;

end.
