{*************
 *
 * Copyright 1999 Anton A. Mints
 *
 * Project....: Freeware components
 * File.......: StrEdtFm.pas
 * Author.....: Anton A. Mints
 * Date.......: 19 January 1999
 * Description: Design time string grid content EXPERT
 *
 * $Archive: $
 *
 * $History: $
 *
 *
 *************}

unit StrEdtFm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DsgnIntf, Grids;

type
  TForm2 = class(TForm)
    btnOk: TButton;
    grdGrid: TStringGrid;
    btnCancel: TButton;
  private
    { Private declarations }
  public
    function ShowModal(AComponent: TStringGrid): Integer;
  end;

  AStringGridEditor = class (TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

var
  Form2: TForm2;

procedure Register;

implementation

{$R *.DFM}

uses
  StringGr;

procedure Register;
begin
  RegisterComponentEditor(TStringGrid, AStringGridEditor);
end;

function TForm2.ShowModal(AComponent: TStringGrid): Integer;
var
  I,J: Integer;
  GridPos: TPoint;
begin
  GridPos := AComponent.Parent.ClientToScreen(AComponent.BoundsRect.TopLeft);
  Top := GridPos.Y - 2;
  Left := GridPos.X - 2;

  grdGrid.Width := AComponent.Width;
  grdGrid.Height := AComponent.Height;
  Width := AComponent.Width + 4;
  Height := AComponent.Height + 31;
  btnOk.Top := AComponent.Height + 4;
  btnOk.Left := Width - btnOk.Width - btnCancel.Width - 4;
  btnCancel.Top := AComponent.Height + 4;
  btnCancel.Left := Width - btnCancel.Width - 2;

  // Load the grid component to editable grid
  grdGrid.RowCount := AComponent.RowCount;
  grdGrid.ColCount := AComponent.ColCount;
  for I := grdGrid.ColCount-1 downto 0 do
  begin
    grdGrid.ColWidths[I] := AComponent.ColWidths[I];
    for J := grdGrid.RowCount-1 downto 0 do
      grdGrid.Cells[I,J] := AComponent.Cells[I,J];
  end;

  Result := inherited ShowModal;

  if (Result = mrCancel) then Exit;

  // Save results
  AComponent.RowCount := grdGrid.RowCount;
  AComponent.ColCount := grdGrid.ColCount;
  for I := AComponent.ColCount-1 downto 0 do
  begin
    AComponent.ColWidths[I] := grdGrid.ColWidths[I];
    for J := AComponent.RowCount-1 downto 0 do
      AComponent.Cells[I,J] := grdGrid.Cells[I,J];
  end;

end;

{**************************************************************************
*                           DESIGN EDITOR                                 *
**************************************************************************}

procedure AStringGridEditor.ExecuteVerb(Index: Integer);
begin
  with TForm2.Create(nil) do
  try
    ShowModal(TStringGrid(Component));
  finally
    Free;
  end;
end;

function AStringGridEditor.GetVerb(Index: Integer): string;
begin
  Result := 'String Editor';
end;

function AStringGridEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

end.
