// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'FFormat.pas' rev: 3.00

#ifndef FFormatHPP
#define FFormatHPP
#include <FFVerc.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Fformat
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS Efex;
class PASCALIMPLEMENTATION Efex : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	int Ind;
	__fastcall Efex(int IndNo);
public:
	/* Exception.Create */ __fastcall Efex(const System::AnsiString Msg) : Sysutils::Exception(Msg) { }
		
	/* Exception.CreateFmt */ __fastcall Efex(const System::AnsiString Msg, const System::TVarRec * Args
		, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall Efex(int Ident, Extended Dummy) : Sysutils::Exception(Ident, Dummy
		) { }
	/* Exception.CreateResFmt */ __fastcall Efex(int Ident, const System::TVarRec * Args, const int Args_Size
		) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall Efex(const System::AnsiString Msg, int AHelpContext) : Sysutils::
		Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall Efex(const System::AnsiString Msg, const System::TVarRec * 
		Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall Efex(int Ident, int AHelpContext) : Sysutils::Exception(Ident
		, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall Efex(int Ident, const System::TVarRec * Args, const int 
		Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~Efex(void) { }
	
};

#pragma pack(push, 1)
struct DiskInformation
{
	Word BytesPerSector;
	Byte SectorsPerCluster;
	Word ReservedSectors;
	Byte FATs;
	Word RootDirectories;
	Word TotalSectors;
	Byte MediaDescriptor;
	Word SectorsPerFAT;
	Word SectorsPerTrack;
	Word Heads;
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct TrackTableInformation
{
	Byte Track;
	Byte Head;
	Byte Sector;
	Byte SectorSizeCode;
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct FormatParamBlock
{
	Byte SpecialFunc;
	Byte DeviceType;
	Word DeviceAttr;
	Word NumOfCyls;
	Byte MediaType;
	DiskInformation BPB;
	Word HiddenSecs;
	Word HiddenSecsHi;
	Word BTotalSecs;
	Word BTotalSecsHi;
	Word BSecsPerFat;
	Word BSecsPerFatHi;
	Word ExtFlags;
	Word NumSecsPerTrack;
	Word PairsNumSizeSec[36];
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct BootInformation
{
	char Name[8];
	DiskInformation DiskInfo;
	int HiddenSectors;
	int SecsInLogicalVol;
	Byte DriveNumber;
	Byte Reserved;
	Byte BootSignature;
	int SerialNumber;
	char Volume[11];
	char FatType[8];
} ;
#pragma pack(pop)

typedef Byte BootArray[512];

enum TMediaType { FUnknown, F360, F1200, F720, F1440 };

typedef DiskInformation DiskInfoArray[5];

typedef TrackTableInformation TrackTableArray[18];

typedef TrackTableArray *TrackTablePtr;

typedef Byte MaxArray[65536];

typedef MaxArray *MaxArrayPtr;

enum TDiskDrive { DriveA, DriveB };

enum TFormatCondition { Always, Never, WhenNeeded };

enum TSystemLocation { DriveC, DriveD, DriveE, DriveF, DriveG, DriveH, DriveI, DriveJ, DriveK, DriveL, 
	DriveM, DriveN, DriveO, DriveP, DriveQ, DriveR, DriveS, DriveT, DriveU, DriveV, DriveW, DriveX, DriveY, 
	DriveZ };

typedef Shortint TRetries;

enum TVerify { VerAlways, VerNever, VerWhenFormatting, VerOnly };

typedef SmallString<8>  StringEight;

typedef SmallString<11>  StringEleven;

class DELPHICLASS TFloppyFormat;
class PASCALIMPLEMENTATION TFloppyFormat : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	System::AnsiString DDV;
	StringEight FSerialNumber;
	StringEight FCustomSerNum;
	int SerNum;
	bool FClearDisk;
	TDiskDrive FDrive;
	TFormatCondition FFormatCondition;
	bool FMakeBootable;
	bool FUseCustomSerNum;
	TMediaType FMediaType;
	TRetries FRetries;
	TSystemLocation FSystemLocation;
	TVerify FVerify;
	StringEleven FVolumeLabel;
	Classes::TNotifyEvent FOnBootWrite;
	Classes::TNotifyEvent FOnFatWrite;
	Classes::TNotifyEvent FOnRootWrite;
	Classes::TNotifyEvent FOnSystemWrite;
	Classes::TNotifyEvent FOnTrackFormat;
	Classes::TNotifyEvent FOnVerify;
	bool FActive;
	TMediaType FDriveType;
	System::AnsiString FErrNoMessage;
	int FErrNo;
	System::AnsiString FErrorMessage;
	Byte FCurrentHead;
	Byte FCurrentTrack;
	Byte FHeads;
	Byte FTracks;
	Byte FSectors;
	int FProgress;
	BootInformation BootInfo;
	TrackTableArray *TrackTable;
	void __fastcall SetDDV(System::AnsiString NewDDV);
	void __fastcall SetVolLabel( StringEleven &LabelVal);
	void __fastcall SetCustomSerNum( StringEight &Str8SerNum);
	TMediaType __fastcall FGetDriveType(void);
	
public:
	bool Cancel;
	__fastcall virtual TFloppyFormat(Classes::TComponent* AOwner);
	__fastcall virtual ~TFloppyFormat(void);
	__property bool IsActive = {read=FActive, nodefault};
	__property TMediaType DriveType = {read=FGetDriveType, nodefault};
	__property System::AnsiString BiosErrorMessage = {read=FErrNoMessage};
	__property int BiosErrorNo = {read=FErrNo, nodefault};
	__property System::AnsiString ErrorMessage = {read=FErrorMessage};
	__property Byte CurrentHead = {read=FCurrentHead, nodefault};
	__property Byte CurrentTrack = {read=FCurrentTrack, nodefault};
	__property Byte Heads = {read=FHeads, nodefault};
	__property Byte Tracks = {read=FTracks, nodefault};
	__property Byte Sectors = {read=FSectors, nodefault};
	__property StringEight SerialNumber = {read=FSerialNumber};
	__property int Progress = {read=FProgress, nodefault};
	bool __fastcall CopyFile(System::AnsiString Source, System::AnsiString Target);
	int __fastcall FormatDisk(void);
	bool __fastcall FormatTrack(Byte Track, Byte Head);
	int __fastcall PhysToLogical(Byte Track, Byte Head, Byte PhysSector);
	int __fastcall ReadSector(int LogicalSector, void * Buffer);
	int __fastcall WriteSector(int LogicalSector, void * Buffer);
	int __fastcall GetDriveType(Byte Drive, Byte &DriveType);
	
__published:
	__property System::AnsiString About = {read=DDV, write=SetDDV};
	__property StringEleven VolumeLabel = {read=FVolumeLabel, write=SetVolLabel};
	__property TDiskDrive DiskDrive = {read=FDrive, write=FDrive, default=0};
	__property bool MakeBootable = {read=FMakeBootable, write=FMakeBootable, default=0};
	__property StringEight CustomSerNum = {read=FCustomSerNum, write=SetCustomSerNum};
	__property bool UseCustomSerNum = {read=FUseCustomSerNum, write=FUseCustomSerNum, default=0};
	__property TMediaType MediaType = {read=FMediaType, write=FMediaType, default=4};
	__property TRetries Retries = {read=FRetries, write=FRetries, default=5};
	__property TSystemLocation SystemLocation = {read=FSystemLocation, write=FSystemLocation, default=0
		};
	__property TVerify Verify = {read=FVerify, write=FVerify, default=1};
	__property TFormatCondition FormatCondition = {read=FFormatCondition, write=FFormatCondition, nodefault
		};
	__property Classes::TNotifyEvent OnBootWrite = {read=FOnBootWrite, write=FOnBootWrite};
	__property Classes::TNotifyEvent OnFatWrite = {read=FOnFatWrite, write=FOnFatWrite};
	__property Classes::TNotifyEvent OnRootWrite = {read=FOnRootWrite, write=FOnRootWrite};
	__property Classes::TNotifyEvent OnSystemWrite = {read=FOnSystemWrite, write=FOnSystemWrite};
	__property Classes::TNotifyEvent OnTrackFormat = {read=FOnTrackFormat, write=FOnTrackFormat};
	__property Classes::TNotifyEvent OnVerify = {read=FOnVerify, write=FOnVerify};
};

//-- var, const, procedure ---------------------------------------------------
#define MaxSectorOnTrack (Byte)(18)
#define MaxArrayValue (int)(65536)
#define FloppySectorSize (Word)(512)
extern PACKAGE void __fastcall Register(void);

}	/* namespace Fformat */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Fformat;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// FFormat
