{This component can be freely used, besides you are invited to
 distribute it in commercial and private environments. I am sure of
 this component could be better, if you have any suggestion or you
 find any bug, please send me to e-mail.}

{ The WavBitBtn playing wave files in the event Click, the Window's
 message WM_KILLFOCUS and the Window's message WM_SETFOCUS,
 but you can playing waves files in others events using
the public procedure Play.}

unit WavBitBtn;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DsgnIntf, StdCtrls, Buttons ,MMSystem;

{The TwavType is used to define the form of the Playing mode}
type
   TwavType = (
      wavNone,
      wavAsync,
      wavSync,
      wavPurge,
      wavLoop
     );

{This Type is only using  for testing both the Wave File and the
 playing mode in design time}
type
   TTestFile = (
      TestClick,
      TestPlay,
      TestEnter,
      TestExit,
      TestStop
     );


type
   TFilenameProperty = class(TStringProperty)
   public
      { Public Declarations }
      procedure Edit; override;
      function GetAttributes: TPropertyAttributes; override;
end;

type
  TWavBitBtn = class(TBitBtn)
  private
     { Private declarations }
  protected
     { Protected declarations }
     FClickFile: String;
     FClickType: TwavType;
     FEnterFile: String;
     FEnterType: TwavType;
     FExitFile: String;
     FExitType: TwavType;
     {The protected members FPlayFile and FPlayType will be playing
      when you use the procedure Play}
     FPlayFile: String;
     FPlayType: TwavType;

     FTestFile: TTestFile;

     {Procedures for set the value of the properties}
     procedure SetClickType(NewClickType: TwavType);
     procedure SetEnterType(NewEnterType: TwavType);
     procedure SetExitType(NewExitType: TwavType);
     procedure SetPlayType(NewPlayType: TwavType);

     procedure SetClickFile(NewClickFile: TFileName);
     procedure SetEnterFile(NewEnterFile: TFileName);
     procedure SetExitFile(NewExitFile: TFileName);
     procedure SetPlayFile(NewPlayFile: TFileName);

     procedure SetTestFile(NewTestFile: TTestFile);

     {This function is used for playing wave files}
     procedure FPlay(const strFile: String; wavType: TWavType);
     procedure FExit(var Msg: TMessage); message WM_KILLFOCUS;
     procedure FEnter(var Msg: TMessage); message WM_SETFOCUS;

  public
    { Public declarations }
    procedure Click; override;
    procedure Play;
    function CanPlay: Boolean;

  published
    { Published declarations }
     property ClickType: TwavType
        read FClickType
        write SetClickType;
     property EnterType: TwavType
        read FEnterType
        write SetEnterType;
     property ExitType: TwavType
        read FExitType
        write SetExitType;
     property PlayType: TwavType
        read FPlayType
        write SetPlayType;
     property ClickFile: String
        read FClickFile
        write SetClickFile;
     property EnterFile: String
        read FEnterFile
        write SetEnterFile;
     property ExitFile: String
        read FExitFile
        write SetExitFile;
     property PlayFile: String
        read FPlayFile
        write SetPlayFile;
     property TestFile: TTestFile
        read FTestFile
        write SetTestFile;
  end;

procedure Register;

implementation

procedure TWavBitBtn.SetClickType(NewClickType: TwavType);
begin
   FClickType:= NewClickType;
end;

procedure TWavBitBtn.SetEnterType(NewEnterType: TwavType);
begin
   FEnterType:= NewEnterType;
end;

procedure TWavBitBtn.SetExitType(NewExitType: TwavType);
begin
   FExitType:= NewExitType;
end;

procedure TWavBitBtn.SetPlayType(NewPlayType: TwavType);
begin
   FPlayType:= NewPlayType;
end;

procedure TWavBitBtn.SetClickFile(NewClickFile: TFileName);
begin
   FClickFile:= NewClickFile;
end;

procedure TWavBitBtn.SetEnterFile(NewEnterFile: TFileName);
begin
   FEnterFile:= NewEnterFile;
end;

procedure TWavBitBtn.SetExitFile(NewExitFile: TFileName);
begin
   FExitFile:= NewExitFile;
end;

procedure TWavBitBtn.SetPlayFile(NewPlayFile: TFileName);
begin
   FPlayFile:= NewPlayFile;
end;

procedure TWavBitBtn.SetTestFile(NewTestFile: TTestFile);
begin
   FTestFile:= NewTestFile;

   case NewTestFile of
      TestClick: FPlay(FClickFile, FClickType);

      TestPlay: FPlay(FPlayFile, FPlayType);

      TestEnter: FPlay(FEnterFile, FEnterType);

      TestExit: FPlay(FExitFile, FExitType);

      TestStop: FPlay('', wavPurge);
   end;
end;

procedure TWAvBitBtn.Click;
begin
   {This procedure will be used when the user clicks the control}
    FPlay(FClickFile, FClickType);
   inherited Click;
end;

procedure TWavBitBtn.FExit(var Msg: TMessage);
begin
   {This procedure will be used when the control losses
   the focus}
   FPlay(FExitFile, FExitType);
end;

procedure TWavBitBtn.FEnter(var Msg: TMessage);
begin
   {This procedure will be used when the control sets
   the focus}
   FPlay(FEnterFile, FEnterType);
end;

procedure TWavBitBtn.Play;
begin
   FPlay(FPlayFile, FPlayType);
end;

function TWavBitBtn.CanPlay: Boolean;
var
   lngValue: LongInt;
begin
   lngValue:= waveOutGetNumDevs();
   if lngValue > 0 then
      result:= True
   else
      result:= False;
end;

procedure TWavBitBtn.FPlay(const strFile: String; wavType: TWavType);
var
  chrFileName: Array [0..255] of Char;
  lngFlags: LongInt;
begin
   lngFlags:= 0;
   if (Length(strFile) <= 250) and (wavType <> wavNone) then
   begin
      StrPCopy(chrFileName, strFile);

      case wavType of
         wavAsync: lngFlags:= SND_ASYNC;

         wavSync: lngFlags:= SND_SYNC;

         wavLoop: lngFlags:= SND_ASYNC or SND_LOOP;

         wavPurge:
         begin
            lngFlags:= SND_PURGE;
            StrPCopy(chrFileName, '');
         end;
      end;

      PlaySound(chrFileName, 0,lngFlags);
   end;
end;

procedure TFilenameProperty.Edit;
var
   OpenDialog : TOpenDialog;
begin
   OpenDialog := TOpenDialog.create(Application);
   try
      OpenDialog.filename := GetValue;
      OpenDialog.filter := 'Wave Files (*.wav)|*.wav|' +
                           'All Files (*.*)|*.*|';
      OpenDialog.options := [ofFileMustExist, ofPathMustExist];

      if OpenDialog.execute then SetValue(OpenDialog.Filename);

   finally
      OpenDialog.free;
   end;
end;

function TFilenameProperty.GetAttributes : TPropertyAttributes;
begin
  result := [paDialog];
end;

procedure Register;
begin
  RegisterComponents('Samples', [TWavBitBtn]);
  RegisterPropertyEditor(TypeInfo(TFileName), TWavBitBtn, '',
		TFilenameProperty);
end;

end.
