unit oaStage;

{ Office 97 Assistant Package v1.0 }
{ Copyright  1999 Kambiz R. Khojasteh }
{ email: Khojasteh@www.dci.co.ir }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TAssistantStage = class(TForm)
    procedure FormResize(Sender: TObject);
  private
    FOnMoving: TNotifyEvent;
    procedure WMMoving(var Message: TMessage); message WM_MOVING;
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure WMNCHitTest(var Message: TWMNCHitTest); message WM_NCHITTEST;
    procedure WMNCLButtonDblClk(var Message: TWMMouse); message WM_NCLBUTTONDBLCLK;
    procedure WMNCLButtonDown(var Message: TWMMouse); message WM_NCLBUTTONDOWN;
    procedure WMNCLButtonUp(var Message: TWMMouse); message WM_NCLBUTTONUP;
    procedure WMNCRButtonUp(var Message: TWMMouse); message WM_NCRBUTTONUP;
    procedure CMBiDiModeChanged(var Message: TMessage); message CM_BIDIMODECHANGED;
  public
    property OnMoving: TNotifyEvent read FOnMoving write FOnMoving;
  end;

implementation

{$R *.DFM}

procedure TAssistantStage.WMMoving(var Message: TMessage);
begin
  inherited;
  if Assigned(FOnMoving) then
    FOnMoving(Self);
end;

procedure TAssistantStage.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin
  Message.Result := 1;
end;

procedure TAssistantStage.WMNCHitTest(var Message: TWMNCHitTest);
begin
  inherited;
  if not Enabled then
    Message.Result := htNoWhere
  else if Message.Result = htClient then
    Message.Result := htCaption;
end;

procedure TAssistantStage.WMNCLButtonDblClk(var Message: TWMMouse);
var
  MousePos: TPoint;
begin
  inherited;
  MousePos := ScreenToClient(SmallPointToPoint(Message.Pos));
  if PtInRect(ClientRect, MousePos) then DblClick;
end;

procedure TAssistantStage.WMNCLButtonDown(var Message: TWMMouse);
var
  MousePos: TPoint;
begin
  inherited;
  MousePos := ScreenToClient(SmallPointToPoint(Message.Pos));
  if Assigned(OnMouseUp) then
    MouseUp(mbLeft, [ssLeft], Message.Pos.X, Message.Pos.Y);
  if PtInRect(ClientRect, MousePos) then Click;
end;

procedure TAssistantStage.WMNCLButtonUp(var Message: TWMMouse);
begin
  inherited;
  if Assigned(OnMouseUp) then
    MouseUp(mbLeft, [ssLeft], Message.Pos.X, Message.Pos.Y);
end;

procedure TAssistantStage.WMNCRButtonUp(var Message: TWMMouse);
begin
  inherited;
  if Assigned(OnMouseUp) then
    MouseUp(mbRight, [ssRight], Message.Pos.X, Message.Pos.Y);
  if Assigned(PopupMenu) then
    PopupMenu.Popup(Message.XPos, Message.YPos);
end;

procedure TAssistantStage.CMBiDiModeChanged(var Message: TMessage);
begin
  inherited;
  if Assigned(PopupMenu) then PopupMenu.BiDiMode := BiDiMode;
end;

procedure TAssistantStage.FormResize(Sender: TObject);
begin
  if Visible then Invalidate;
end;

end.
