unit oaTypes;

{ Office 97 Assistant Package v1.0 }
{ Copyright  1999 Kambiz R. Khojasteh }
{ email: Khojasteh@www.dci.co.ir }

interface

uses
  Windows, Classes, SysUtils, Dialogs, Forms;

type

  TRequestID = Cardinal;

  TBalloonKind = (bkNone, bkMessage, bkTips, bkGuide, bkSpeak, bkThink);

  TBalloonPos = (bpCenter, bpTopLeft, bpTopRight, bpRightTop, bpRightBottom,
    bpBottomRight, bpBottomLeft, bpLeftBottom, bpLeftTop);

  TBgMode = (bmNone, bmTiled, bmCentered, bmStretched);

  TExitType = (etNone, etAnimation, etExitBranch);

  TTipsDlgBtn = (tbClose, tbNext, tbBack);
  TTipsDlgButtons = set of TTipsDlgBtn;

  TGuideDlgBtn = (gbClose, gbOptions, gbTips, gbSearch, gbBackPage, gbNextPage);
  TGuideDlgCmdBtn = gbClose..gbSearch;
  TGuideDlgNavBtn = gbBackPage..gbNextPage;
  TGuideDlgButtons = set of TGuideDlgCmdBtn;

  TActorAction = (aaNone, aaAcknowledge, aaAlert, aaAnnounce, aaBlink,
     aaConfused, aaCongratulate, aaDecline, aaDoMagic, aaDontRecognize,
     aaExplain, aaGestureDown, aaGestureLeft, aaGestureRight, aaGestureUp,
     aaGetAttention, aaGetAttentionContinued, aaGlanceDown, aaGlanceLeft,
     aaGlanceRight, aaGlanceUp, aaGreet, aaHear, aaHearing, aaHide,
     aaIdlingLevel1, aaIdlingLevel2, aaIdlingLevel3, aaListen, aaListening,
     aaLookDown, aaLookLeft, aaLookRight, aaLookUp, aaMoveDown, aaMoveLeft,
     aaMoveRight, aaMoveUp, aaPleased, aaProcess, aaProcessing, aaRead,
     aaReadContinued, aaReading, aaRestPose, aaSad, aaSearch, aaSearching,
     aaShow, aaSpeak, aaSpeaking, aaStartListening, aaStopListening, aaSuggest,
     aaSurprised, aaThink, aaThinking, aaUncertain, aaWave, aaWrite,
     aaWriteContinued, aaWriting);

  TOrientedAction = (oaGesture, oaGlance, oaLook, oaMove);

  TIdleLevel = aaIdlingLevel1..aaIdlingLevel3;

  TActorActions = set of TActorAction;

  PAnimationInfo = ^TAnimationInfo;
  TAnimationInfo = record
    Name          : String[255];
    Resource      : Word;
    Actions       : TActorActions;
    HasSound      : Boolean;
  case ExitType   : TExitType of
    etNone        : ();
    etAnimation   : (ReturnIndex: Word);
    etExitBranch  : ();
  end;

  PActorInfo = ^TActorInfo;
  TActorInfo = record
    ID: Word;
    Version: LongInt;
    Copyright: String[255];
    ActorName: String[255];
    AnimationWidth: Byte;
    AnimationHeight: Byte;
    AnimationCount: Word;
    Animations: array[1..1] of TAnimationInfo;
  end;

  TAnimation = record
    Name: String[255];
    Actions: TActorActions;
    HasSound: Boolean;
    case ExitType: TExitType of
      etNone: ();
      etAnimation: (ReturnName: String[255]);
      etExitBranch: ();
  end;

  TIdleEvent = procedure(Sender: TObject; Level: Integer; var Handled: Boolean) of object;
  TPlayEvent = procedure(Sender: TObject; RequestID: TRequestID) of object;

  TTipsTipChangeEvent = TNotifyEvent;

  TGuideRequestChangeEvent = TNotifyEvent;
  TGuideOptionsClickEvent = TNotifyEvent;
  TGuideSearchClickEvent = TNotifyEvent;
  TGuideTopicClickEvent = procedure(Sender: TObject;  TopicIndex: Integer) of Object;

  TAboutMe = class(TObject);

implementation

end.
