(* -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-

   Unit name         : paArcMain.PAS
   Version           : 0.1
   Date              : 1st January 2000
   Copyright/Author  : Copyright 2000 by Ivan Petrovic

   Info              : Unit for viewing many compressed file formats
   Supported formats :
     RAR by Eugene Roshal
     ZOO by Rahul Dhesi
     SQZ by Jonas I Hammarberg
     HYP by P. Sawatzki & K. P. Nischke
     ARC by System Enhancement Associates, Inc.
     PAK by NoGate Consulting
     ARJ by Robert Jung & ARJ Software

   Web-site:  http://ipsoft.cjb.net
   Email   :  ivanpetrov@hotmail.com

   -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
   LICENSE INFORMATION (!!! Please read this !!!)

   The paCompression  Components   source   and   binaries ("software")    are
   copyrighted.  However, I am distributing this software for free and you are
   licensed to use this software without any charge.

   I  encourage you to  redistribute  this software.  Please do  share it with
   your friends.  However, as I am making this software available for free,you
   must do the same.  You are  not  permitted   by this  license to request or
   accept any remuneration of any kind for  this  software.  This  prohibition
   extends   to  including  my  software with any other product or service for
   which money is charged.

   The  only exceptions to this "don't charge for what I' m  giving  away  for
   free" restriction are as follows:

    (1) Online software distribution systems  (e.g., bulletin  board systems,
        FTP sites,   web sites) or  other electronic information services are
        permitted  to make this software   available  for download and charge
        their customary fees, if any, for access to the service.

    (2) Users groups and other not-for-profit  organizations  that distribute
        this  software  may charge a reasonable fee to cover  duplication and
        related costs.

    (3) There may be other  situations not  covered  by  this  license  where
        some  charge  for  distribution  would  be  appropriate.   Contact me
        and we'll talk  about it.  But, this license  does  not authorize any
        such  distribution without express,  written  permission from  me  in
        advance.

   You MAY NOT distribute modified version without my agreement.

   With my agreement  you  may  distribute  modified  copies  of   my   source
   and   resulting executables (including programs derived from mine in  other
   languages or for other operating systems) so long as  you   do    so    for
   free and  pursuant to a license no more restrictive than this one. You MUST
   state that your software was derived from mine.

   If you have any suggestions for improvement, please contact me. If you give
   me few realized ideas I will put your name in Co-Author list.

   This software is provided "as is" and is without warranty  of   any   kind.
   The  author  of  this software does not warrant, guarantee   or   make  any
   representations regarding the use or results of  use   of   this   software
   in terms  of reliability,  accuracy   or   fitness for purpose.  You assume
   the   entire  risk  of direct or indirect, consequential or inconsequential
   results  from  the  correct or incorrect usage of this software even if the
   author  has  been  informed  of the possibilities of  such  damage. Neither
   the  author  nor   anybody connected to this software in any way can assume
   any responsibility.

   -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
   HISTORY:
     * 1st January 2000 -= v0.1 =-
       first initial release - supports reading standard RAR,  ZOO,  SQZ, HYP,
       ARC, PAK and ARJ files

   -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
   TO DO:
     * formats to add: ZIP, ACE, LHA, HAP, J, UC2, HA, TAR, GZ, BH
     * multi volume support
     * password support
     * comment support
     * SFX support
     * ARJ SFX security, ARJ security support
     * RAR <= 1.5 format

   -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-*)
UNIT paArcMain;

INTERFACE

USES
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  paArcUtils;

TYPE
  TArcFile=RECORD
    FileName    : STRING;
    DateTime    : TDateTime;
    Comp_Size   : DWord;
    UnComp_Size : DWord;
    Ratio       : Byte;
    ISProtected : Boolean;
    FileComment : STRING;
    OS          : Byte;
    CRC         : DWord;
    Method      : Byte;
    Attr        : DWord;
    Unp_Ver     : Byte;
  END;

  TpaArcMain = CLASS(TComponent)
  PRIVATE
    FArchiveFile : STRING;
    FP           : FILE OF BYTE;

    PROCEDURE SetArchiveFile(FileName : STRING);
    FUNCTION  GetByte : Byte;
    FUNCTION  GetWord : Word;
    FUNCTION  GetDWord : DWord;
    PROCEDURE ResetF( x : Word );
    FUNCTION  CalcRatio( PackSize, UnCompSize : DWORD ) : Byte;
    PROCEDURE Read_RAR;
    PROCEDURE Read_ZOO;
    PROCEDURE Read_ARC;
    PROCEDURE Read_SQZ;
    PROCEDURE Read_HYP;
    PROCEDURE Read_ARJ;
    PROCEDURE ProcessArchive ( FileName : STRING );

  PROTECTED

  PUBLIC
    Files : ARRAY[1..10000] OF TArcFile;
    NrFiles : Word;
    Version : STRING;

    CONSTRUCTOR Create(AOwner : TComponent); OVERRIDE;
  PUBLISHED
    PROPERTY ArchiveFile : STRING READ FArchiveFile WRITE SetArchiveFile;
  END;

PROCEDURE REGISTER;

IMPLEMENTATION

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
CONSTRUCTOR TpaArcMain.Create(AOwner : TComponent);
BEGIN
  INHERITED Create(AOwner);
  Version := '0.1';
END;

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
PROCEDURE Register;
BEGIN
  RegisterComponents('paCompression', [TpaArcMain]);
END;

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
// Gets 1 byte (Char, Byte)
// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
FUNCTION TpaArcMain.GetByte : Byte;
VAR
  NumRead : Integer;
  B       : Byte;
BEGIN
  BlockRead(FP, B, 1, NUMREAD);
  Result := B;
END;

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
// Gets 2 bytes (Integer, Word)
// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
FUNCTION TpaArcMain.GetWord : Word;
VAR
  NumRead : Integer;
  W       : Word;
BEGIN
  BlockRead(FP, W, 2, NUMREAD);
  Result := W;
END;

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
// Gets 4 bytes (DWord)
// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
FUNCTION TpaArcMain.GetDWord : DWord;
VAR
  NumRead : Integer;
  W       : DWord;
BEGIN
  BlockRead(FP, W, 4, NUMREAD);
  Result := W;
END;

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
// Resets Files[x] record
// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
PROCEDURE TpaArcMain.ResetF( x : Word );
BEGIN
  Files[x].FileName    := '';
  Files[x].DateTime    := 0;
  Files[x].Method      := 0;
  Files[x].IsProtected := False;
  Files[x].OS          := 0;
  Files[x].Attr        := 0;
  Files[x].Unp_ver     := 0;
  Files[x].CRC         := 0;
  Files[x].FileComment := '';
  Files[x].Ratio       := 0;
END;

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
// Resets Files[x] record
// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
FUNCTION TpaArcMain.CalcRatio( PackSize, UnCompSize : DWORD ) : Byte;
BEGIN
  IF (UnCompSize > 0) THEN Result := Round( (1 - (PackSize / UnCompSize)) * 100)
    ELSE Result := 0;
END;

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
// Reads RAR files (RAR version >= 1.50)
// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
PROCEDURE TpaArcMain.Read_RAR;
VAR
  i        : Integer;
  b        : Byte;
  w        : Word;
  dw       : DWord;
  hdr_size : Word;
  s        : STRING[255];
BEGIN
  NrFiles := 0;

  AssignFile(FP, FArchiveFile);
    Reset(FP);

    (* MARK_HEAD *)
    IF (GetByte <> $52) THEN BEGIN END;                (* HEAD_CRC            *)
    IF (GetByte <> $61) THEN BEGIN END;                (* HEAD_CRC            *)
    IF (GetByte <> $72) THEN BEGIN END;                (* HEAD_TYPE           *)
    IF (GetByte <> $21) THEN BEGIN END;                (* HEAD_FLAGS          *)
    IF (GetByte <> $1a) THEN BEGIN END;                (* HEAD_SIZE           *)
    b := GetByte; b:= GetByte;

    (* MAIN_HEAD *)
    w := GetWord;                                      (* HEAD_CRC            *)
    IF (GetByte <> $73) THEN BEGIN END;                (* HEAD_TYPE           *)
    w := GetWord;                                      (* HEAD_FLAGS          *)
    IF (w AND $02 <> 0) THEN BEGIN END;
    IF (w AND $04 <> 0) THEN BEGIN END;
    IF (w AND $08 <> 0) THEN BEGIN END;
    IF (w AND $20 <> 0) THEN BEGIN END;
    hdr_size := GetWord;                               (* HEAD_SIZE           *)
    w := GetWord;                                      (* RESERVED1           *)
    dw := GetDWord;                                    (* RESERVED2           *)
    (* COMMENT BLOCK *)
    Seek(FP, FilePos(FP) + (hdr_size-13));

    (* FILE HEADER *)

    WHILE (FilePos(FP) < FileSize(FP)) DO BEGIN
      w := GetWord;                                    (* HEAD_CRC            *)
      IF (GetByte <> $74) THEN BEGIN END;              (* HEAD_TYPE           *)
      Inc(NrFiles); ResetF(NrFiles);
      w := GetWord;                                    (* HEAD_FLAGS          *)
      IF (w AND $01 <> 0) THEN BEGIN END;
      IF (w AND $02 <> 0) THEN BEGIN END;
      IF (w AND $04 <> 0) THEN Files[NrFiles].IsProtected := True;
      IF (w AND $08 <> 0) THEN BEGIN END;
      IF (w AND $10 <> 0) THEN BEGIN END;
      IF (w AND $01 <> 0) THEN BEGIN END;

      hdr_size := GetWord;                             (* HEAD_SIZE           *)

      dw := GetDWord;                                  (* PACK_SIZE           *)
      Files[NrFiles].Comp_Size := dw;
      dw := GetDWord;                                  (* UNP_SIZE            *)
      Files[NrFiles].UnComp_Size := dw;
      Files[NrFiles].Ratio := CalcRatio (Files[NrFiles].Comp_Size, Files[NrFiles].UnComp_Size);
      b  := GetByte;                                   (* HOST_OS             *)
      Files[NrFiles].OS := b;
      dw := GetDWord;                                  (* FILE_CRC            *)
      Files[NrFiles].CRC := dw;
      dw := GetDWord;                                  (* FTIME               *)
      Files[NrFiles].DateTime := FileDateToDateTime(dw);
      b := GetByte;                                    (* UNP_VER             *)
      Files[NrFiles].Unp_Ver := b;
      b := GetByte;                                    (* METHOD              *)
      Files[NrFiles].Method := b;
      w := GetWord;                                    (* NAME_SIZE           *)
      dw := GetDWord;                                  (* ATTR                *)
      Files[NrFiles].Attr := dw;

      FOR i:=1 TO w DO s[i] := Chr( GetByte );         (* FILE_NAME           *)
      s[0] := Chr ( w );
      Files[NrFiles].FileName := s;

      (* COMMENT BLOCK *)
      Seek(FP, FilePos(FP) + (hdr_size-(32+w)));

      (* COMPRESSED FILE *)
      Seek(FP, FilePos(FP) + (Files[Nrfiles].Comp_Size));
    END;
  Close(FP);
END;

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
// Reads ZOO files
// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
PROCEDURE TpaArcMain.Read_ZOO;
VAR
  i        : Integer;
  b        : Byte;
  w        : Word;
  dw       : DWord;
  next     : DWord;
  hdr_size : Word;
  s        : STRING[255];
BEGIN
  NrFiles := 0;

  AssignFile(FP, FArchiveFile);
    Reset(FP);

    (* ARCHIVE HEADER *)
    Seek(FP, 20);
    dw := GetDWord;
    IF (dw <> $0FDC4A7DC) THEN BEGIN END;              (* ARCHIVE ID          *)
    hdr_size := GetDWord;                              (* OFFSET OF FIRST FILE*)
    dw := GetDWord;                                    (* OFFSET OF ???       *)
    GetByte; GetByte;                                  (* ARCHIVER VERSION    *)

    WHILE (TRUE) DO BEGIN
      (* FILE HEADER *)
      Seek(FP, hdr_size);
      dw := GetDWord;                                  (* FILE HEADER ID      *)
      IF (dw <> $0FDC4A7DC) THEN Break;
      Inc(NrFiles); ResetF(NrFiles);
      b  := GetByte;                                   (* TYPE OF DIR ENTRY   *)
      b  := GetByte;                                   (* COMPRESSION METHOD  *)
      Files[NrFiles].Method := b;
      next     := GetDWord;                            (* OFFSET OF NEXT ENTRY*)
      IF (next = 0) THEN BEGIN Dec(NrFiles); Break; END;
      dw:= GetDWord;
      Seek(FP, hdr_size+13);
      dw  := GetDWord;                                 (* ORGINAL DATE / TIME *)
      Files[NrFiles].DateTime := FileDateToDateTime(dw);
      Seek(FP, hdr_size+18);
      w  := GetDWord;                                  (* 16-bit CRC          *)
      Files[NrFiles].Crc := w;
      Seek(FP, hdr_size+20);
      dw := GetDWord;                                  (* UNCOMPRESSED SIZE   *)
      Files[NrFiles].UnComp_Size:=dw;
      dw := GetDWord;                                  (* COMPRESSED SIZE     *)
      Files[NrFiles].Comp_Size:=dw;
      Files[NrFiles].Ratio := CalcRatio (Files[NrFiles].Comp_Size, Files[NrFiles].UnComp_Size);
      b  := GetByte;                                   (* ARCHIVER VERSION    *)
      b  := GetByte;                                   (* MIN. EXTR. VERSION  *)
      Files[NrFiles].Unp_Ver := b;
      b  := GetByte;                                   (* DELETED FLAG        *)
      dw := GetDWord;                                  (* OFFSET OF COMMENT   *)
      w := GetWord;                                    (* COMMENT LENGHT      *)
      GetByte;
      S:='';                                           (* PATH / FILENAME     *)
      WHILE (TRUE) DO BEGIN
        B := GetByte;
        IF (B=0) THEN Break;
        S:=S+Chr(b);
      END;
      Files[NrFiles].FileName := s;
      hdr_size := next;
    END;
  Close(FP);
END;

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
// Reads SQZ files (Squeeze It)
// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
PROCEDURE TpaArcMain.Read_SQZ;
VAR
  i        : Integer;
  b        : Byte;
  w        : Word;
  dw       : DWord;
  hdr_size : Word;
  s        : STRING[255];
BEGIN
  NrFiles := 0;

  AssignFile(FP, FArchiveFile);
    Reset(FP);

    (* ARCHIVE HEADER *)
    IF (GetByte <> 72) THEN BEGIN END;
    IF (GetByte <> 76) THEN BEGIN END;
    IF (GetByte <> 83) THEN BEGIN END;
    IF (GetByte <> 81) THEN BEGIN END;
    IF (GetByte <> 90) THEN BEGIN END;

    b := GetByte;                                      (* OS                  *)
    b := GetByte;                                      (* FLAG                *)

    (* FILE HEADER *)
    WHILE (FilePos(FP)<FileSize(FP)) DO BEGIN
      hdr_size := GetByte;
      IF (hdr_size = 0) OR (hdr_size=255) THEN BREAK;
      IF (hdr_size > 18) THEN BEGIN
        Inc(NrFiles);
        b := GetByte;
        b := GetByte;
        dw := GetDWord;                                (* COMPRESSED SIZE     *)
        Files[NrFiles].Comp_Size := dw;
        dw := GetDWord;                                (* ORGINAL SIZE        *)
        Files[NrFiles].UnComp_Size := dw;
        Files[NrFiles].Ratio := CalcRatio (Files[NrFiles].Comp_Size, Files[NrFiles].UnComp_Size);
        dw := GetDWord;                                (* LAST DATE           *)
        Files[NrFiles].DateTime := FileDateToDateTime (dw);
        b := GetByte;                                  (* ATTRIBUTES          *)
        Files[NrFiles].Attr := b;
        dw := GetDword;                                (* CRC                 *)
        Files[NrFiles].CRC := dw;
        FOR i:=1 to hdr_size-18 DO
          s[i] := Chr(GetByte);
        s[0]:=chr(hdr_size-18);
        Files[NrFiles].FileName := s;
        Seek(FP, FilePos(FP)+Files[NrFiles].Comp_Size);
      END ELSE BEGIN
        (* EXTRA HEADER *)
        b := GetByte;
        w := GetWord; Seek(FP, FilePos(FP)+w);
      END;
   END;

  Close(FP);
END;

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
// Reads HYP files (Hyper)
// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
PROCEDURE TpaArcMain.Read_HYP;
VAR
  i        : Integer;
  b        : Byte;
  w        : Word;
  dw       : DWord;
  hdr_size : Word;
  s        : STRING[255];
BEGIN
  NrFiles := 0;


  AssignFile(FP, FArchiveFile);
    Reset(FP);

    WHILE (FilePos(FP)<FileSize(FP)) DO BEGIN
      Inc(NrFiles);
      IF (GetByte <> $1A) THEN BEGIN END;
      s := Chr(GetByte) + Chr(GetByte);                (* COMPRESSION METHOD  *)
      IF (s = 'HP') THEN BEGIN Files[NrFiles].Method:=0; END;
      IF (s = 'ST') THEN BEGIN Files[NrFiles].Method:=1; END;
      b := GetByte;                                    (* VERSION             *)
      Files[NrFiles].Unp_ver := b;
      Files[NrFiles].Comp_Size := GetDWord;                                  (* COMPRESSED SIZE     *)
      dw := GetDWord;                                  (* ORGINAL SIZE        *)
      Files[NrFiles].UnComp_Size := dw;
      dw := GetDWord;                                  (* MS-DOS DATE & TIME  *)
      Files[NrFiles].DateTime := FileDateToDateTime (dw);
      dw := GetDWord;                                  (* CRC                 *)
      Files[NrFiles].CRC := dw;
      b := GetByte;                                    (* MS-DOS ATTRIBUTE    *)
      Files[NrFiles].Attr := b;
      b := GetByte;
      FOR i:=1 to b DO
        s[i] := Chr(GetByte);
      s[0]:=Chr(b);
      Files[NrFiles].FileName := s;
      Seek(FP, FilePos(FP) + Files[NrFiles].Comp_Size);
    END;
  Close(FP);
END;

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
// Reads ARC files
// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
PROCEDURE TpaArcMain.Read_ARC;
VAR
  i        : Integer;
  b        : Byte;
  w        : Word;
  dw       : DWord;
  hdr_size : Word;
  s        : STRING[255];
BEGIN
  NrFiles := 0;

  AssignFile(FP, FArchiveFile);
    Reset(FP);
    WHILE (FilePos(FP) < FileSize(FP)) DO BEGIN
      hdr_size := FilePos(FP);
      IF (GetByte <> $1A) THEN BEGIN BREAK; END;
      b := GetByte;                                    (* COMPRESSION METHOD  *)
      IF (b = 0) THEN Break;
      Inc(NrFiles);
      Files[NrFiles].Method:=b;
      S:='';                                           (* FILE NAME           *)
      WHILE (True) DO BEGIN 
        B:=GetByte;
        IF (B=255) OR (B=0) THEN BREAK
          ELSE s:=s+Chr(b);
      END;
      Files[NrFiles].FileName := s;
      Seek(FP, hdr_size + 15);
      Files[NrFiles].Comp_Size := GetDWord;            (* COMPRESSED FILE SIZE*)
      dw := GetDWord;                                  (* DATE IN DOS FORMAT  *)
//      Files[NrFiles].DateTime := FileDateToDateTime(dw);
      w := GetWord;                                    (* 16-bit CRC          *)
      Files[NrFiles].CRC := w;
      Files[NrFiles].UnComp_Size := GetDWord;          (* ORGINAL FILE SIZE   *)
      Seek(FP, FilePos(FP) + Files[NrFiles].Comp_Size);
    END;
  Close(FP);
END;

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
// Reads ARJ files
// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
PROCEDURE TpaArcMain.Read_ARJ;
VAR
  i        : Integer;
  b        : Byte;
  w        : Word;
  dw       : DWord;
  hdr_size : Word;
  s        : STRING[255];
BEGIN
  NrFiles := 0;

  AssignFile(FP, FArchiveFile);
    Reset(FP);

    b := GetByte;                                      (* HEADER ID           *)
    b := GetByte;                                      (* HEADER ID           *)
    w := GetWord;                                      (* HEADER SIZE         *)
    b := GetByte;                                      (* 1st HEADER SIZE     *)
    b := GetByte;                                      (* ARCHIVER VER. NUM.  *)
    b := GetByte;                                      (* MIN. VER. TO EXTR.  *)
    b := GetByte;                                      (* OS                  *)
    b := GetByte;                                      (* ARJ FLAGS           *)
    b := GetByte;                                      (* SECURITY VERSION    *)
    b := GetByte;                                      (* FILE TYPE           *)
    b := GetByte;                                      (* RESERVED            *)
    dw := GetDWord;                                    (* CREATED DATE        *)
    dw := GetDWord;                                    (* MODIFIED DATE       *)
    dw := GetDWord;                                    (* ARCHIVE SIZE        *)
    dw := GetDWord;                                    (* SEC. ENVELOPE F. POS*)
    w := GetWord;                                      (* *)
    w := GetWord;
    w := GetWord;

    S:='';
    WHILE (TRUE) DO BEGIN
      B := GetByte;
      IF (B=0) THEN Break;
      S:=S+Chr(b);
    END;
    S:='';
    WHILE (TRUE) DO BEGIN
      B := GetByte;
      IF (B=0) THEN Break;
      S:=S+Chr(b);
    END;
    dw := GetDWord;
    w := GetWord;
    IF (w <> 0) THEN BEGIN
      Seek (FP, FilePos(FP) + w);
      dw := GetDWord;
    END;
    WHILE (FilePos(FP) < FileSize(FP)) DO BEGIN
      IF (GetByte <> $60) THEN BEGIN END;
      IF (GetByte <> $EA) THEN BEGIN END;
      w := GetWord;
      if (w = 0) THEN Break;
      inc(NrFiles);

      b := GetByte;
      b := GetByte;
      b := GetByte;
      Files[NrFiles].Unp_ver := b;
      b := GetByte;
      Files[NrFiles].OS := b;
      b := GetByte;
      b := GetByte;
      Files[NrFiles].Method := b;
      b := GetByte;
      b := GetByte;
      dw := GetDWord;
      Files[NrFiles].DateTime := FileDateToDateTime (dw);
      dw := GetDWord;
      files[nrfiles].comp_size:=dw;
      dw := GetDWord;
      files[nrfiles].Uncomp_size:=dw;
      dw := GetDWord;
      files[nrfiles].crc:=dw;
      w := GetWord;
      w := GetWord;
      w := GetWord;
    S:='';
    WHILE (TRUE) DO BEGIN
      B := GetByte;
      IF (B=0) THEN Break;
      S:=S+Chr(b);
    END;
      Files[NrFiles].FileName:=s;
    S:='';
    WHILE (TRUE) DO BEGIN
      B := GetByte;
      IF (B=0) THEN Break;
      S:=S+Chr(b);
    END;
    Files[NrFiles].FileComment:=s;
    dw := GetDword;
    w := GetWord;
      IF (w <> 0) THEN BEGIN
        Seek(FP, FilePos(FP) + w);
        dw := GetDWord;
      END;
      Seek(FP, FilePos(FP) + Files[NrFiles].Comp_Size);
    END;
  Close(FP);
END;

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
PROCEDURE TpaArcMain.ProcessArchive ( FileName : STRING );
VAR
  Ext : STRING;
BEGIN
  Ext := Down(ExtractFileExt(FileName));
  IF (Ext = '.rar') THEN Read_RAR;
  IF (Ext = '.sqz') THEN Read_SQZ;
  IF (Ext = '.hyp') THEN Read_HYP;
  IF (Ext = '.zoo') THEN Read_ZOO;
  IF (Ext = '.arc') OR (Ext = '.pak') THEN Read_ARC;
  IF (Ext = '.arj') THEN Read_ARJ;
END;

// -=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=--=-
PROCEDURE TpaArcMain.SetArchiveFile(FileName : STRING);
BEGIN
  FArchiveFile := FileName;
  ProcessArchive (FArchiveFile);
END;

end.
